<?php
    /**
    * The functions file for for displaying the mp3 player
    *
    * @package mp3-player
    */


    $countGlobal=0;


    class simple_mp3_player{


        function javascript_and_css(){   


            echo '<script type="text/javascript">
            //<![CDATA[
            var site_url=  \''.site_url().'\';                            
            //]]>
            </script>';


            return ;

        }

        /**
        * Load the Thickbox JavaScript if needed.
        *
        * @since 0.8
        */
        function simple_mp3_player_enqueue_script() {

            wp_enqueue_script('jquery');
            add_action('wp_print_scripts', array($this,'javascript_and_css'));
            wp_enqueue_script('simple_mp3_player_js', WP_CONTENT_URL . '/plugins/mp3-player/javascript.js', array('jquery'));

            wp_enqueue_script('simple_mp3_player_js2', WP_CONTENT_URL . '/plugins/mp3-player/js.js', array('jquery'));


            wp_enqueue_style('simple_mp3_style', WP_CONTENT_URL . '/plugins/mp3-player/style.css');

        }

        /**
        * Constructor
        * 
        */
        function simple_mp3_player(){

            /* Load any scripts needed. */
            add_action( 'template_redirect', array($this,'simple_mp3_player_enqueue_script' ));


            return;
        }

        function init($attr) {


            global $post;

            /* Orderby. */
            if ( isset( $attr['orderby'] ) ) {
                $attr['orderby'] = sanitize_sql_orderby( $attr['orderby'] );
                if ( !$attr['orderby'] )
                    unset( $attr['orderby'] );
            }

            /* Default gallery settings. */
            $defaults = array(
            'order' => 'ASC',
            'orderby' => 'menu_order ID',
            'id' => $post->ID,
            'link' => 'full',
            'itemtag' => 'dl',
            'icontag' => 'dt',
            'captiontag' => 'dd',
            'columns' => 3,
            'size' => 'thumbnail',
            'include' => '',
            'exclude' => '',
            'numberposts' => -1,
            'offset' => ''
            );


            /* Merge the defaults with user input. Make sure $id is an integer. */
            extract( shortcode_atts( $defaults, $attr ) );

            /* $arg= shortcode_atts( $defaults, $attr ) ;
            $arg['order'];
            $arg['orderby'];
            $arg['id'];
            $arg['link'];
            $arg['itemtag'];
            $arg['icontag'];
            $arg['captiontag'];
            $arg['columns'];
            $arg['size'];
            $arg['include'];
            $arg['exclude'];
            $arg['numberposts'];
            $arg['offset'];
            */
            $id = intval( $id );

            /* Arguments for get_children(). */
            $children = array(
            'post_parent' => $id,
            'post_status' => 'inherit',
            'post_type' => 'attachment',
            //'post_mime_type' => 'image',
            //'post_mime_type' => 'audio',
            'post_mime_type' => '',
            'order' => $order,
            'orderby' => $orderby,
            'exclude' => $exclude,
            'include' => $include,
            'numberposts' => $numberposts,
            'offset' => $offset,
            );


            /* Get image attachments. If none, return. */
            $attachments = get_children( $children );



            //print_r($attachments);
            if ( empty( $attachments ) )
                return '';

            /* If is feed, leave the default WP settings. We're only worried about on-site presentation. */
            if ( is_feed() ) {
                $output = "\n";
                foreach ( $attachments as $id => $attachment )
                    $output .= wp_get_attachment_link( $id, $size, true ) . "\n";
                return $output;
            }

         

            $post_id =  $id ;

         
            $output=$this->render($attachments,$post_id,$title,$link);
            return $output;

        }


        /**
        * Display
        * 
        * @param mixed $attachments
        * @param mixed $post_id
        * @param mixed $itemtag
        * @param mixed $icontag
        * @param mixed $id
        * @param mixed $title
        * @param mixed $size
        * @param mixed $link
        * @param mixed $attributes
        */
        function render($attachments,$post_id,$title,$link){
            global  $countGlobal ;

            // generating the js playlist
            if($countGlobal<1){
                $p='var playlist=new Array();';
            }
            $countGlobal++;
            $javascript="<script type=\"text/javascript\">

            ".$p."  
            playlist['".$post_id."']=new Array()
            ";

            $i=0;
            foreach ( $attachments as $id => $attachment ) {

                if($attachment->post_mime_type=='audio/mpeg'){
                    //$javascript.="playlist[".$post_id."][".$i."]='".$attachment->guid."';\n";
                    $javascript.="playlist[".$post_id."][".$i."]='".wp_get_attachment_url( $id ) ."';\n";

                    $i++;   
                }  

            }

            $javascript.="  
            </script>";
            $output=$javascript;


            //using the first gallery-image as cover
            foreach ( $attachments as $id => $attachment ) { 

                if($attachment->post_mime_type=='image/jpeg'){    
                    $img_src = wp_get_attachment_image_src( $id, $link );
                    $size='medium';    
                    $img = wp_get_attachment_image_src( $id, $size );

                    $bild = '<img style="float:right" src="' . $img[0] . '" alt="' . $title . '" title="' . $title . '" />';


                }

            }

            add_action('wp_footer',array($this,'renderFlashPlayer'));



            $output.= "\t\t\t


            <div  class='simple-mp3-player-holder' >".$bild;
            $output .= "\n\t\t\t\t<div class='simple-mp3-player'>";


            /* Loop through each attachment. */

            $i=0;
            foreach ( $attachments as $id => $attachment ) {


                if($attachment->post_mime_type=='audio/mpeg'){

                    $title = esc_attr( $attachment->post_title );

                    $output .= "<div class='mp3-item'  >";

                    $output .= "<div >";

                    $filename=$id;
                    $title;

                    $output .='<div>
                    <a class="download" style="float:right;line-height:12px;" href="'.$_SERVER['PHP_SELF'].'/?mp3PlayerFile='.$filename.'&title='.$title.'" >&nbsp</a>
                    <a class="playBtn" Id="track_'.$post_id.'_'.$i.'" onclick="return false" href="#" class="playBtn" >'.$title .'</a>

                    </div>';
                    $i++;
                    $output .= "</div>";

                    $output .= "</div>";
                }  

            }




            $output .= $this->renderPlayer($post_id).'

            </div>
            <div class="playerclear" ><!--empty commment--></div>

            </div>';




            return $output;
        }

        function renderPlayer($post_id){

            $player=' 
            <div id="playercontroller_'.$post_id.'" class="playercontroller">
            <div id="playerplay'.$post_id.'" class="button play"><a href="javascript:playIt('.$post_id.')" >PLAY</a>


            </div>
            <div id="playerpause'.$post_id.'" class="button pause"><a href="javascript:pause()">PAUSE</a></div>
            <div id="playerstop'.$post_id.'" class="button stop"><a href="javascript:stop()">STOP</a></div>
            <div class="timeline"></div>
            <div class="carpe_horizontal_slider_track">
            <div class="carpe_slider_slit"></div>
            <div class="timeline carpe_slider" id="slider'.$post_id.'" display="display1" style="left:0px"></div>
            </div>                   
            <span class="info_bytes" id="info_bytes'.$post_id.'">loaded</span>
            </div>';  
            return $player;
        }

        function renderFlashPlayer(){


            echo '<!--[if IE]>
            <script type="text/javascript" event="FSCommand(command,args)" for="myFlash">
            eval(args);
            </script>
            <![endif]-->
            <object class="playerpreview" id="myFlash" type="application/x-shockwave-flash" data="'.site_url().'/wp-content/plugins/mp3-player/player_mp3_js.swf" width="1" height="1">
            <param name="movie" value="'.site_url().'/wp-content/plugins/mp3-player/player_mp3_js.swf" />

            <param name="AllowScriptAccess" value="always" />
            <param name="FlashVars" value="listener=myListener&amp;interval=500" />

            </object>


            ';
        }

    }
?>